/*
 * hardware.c
 *
 *  Created on: Nov 11, 2019
 *      Author: Sergei
 */
#include "em_device.h"

void EMU_setup(void)
{
	EMU->PWRCFG = EMU_PWRCFG_PWRCFG_DCDCTODVDD;		// unlock DCDC registers
	EMU->DCDCMISCCTRL = 15<<16;						// set 320mA current limit
	EMU->DCDCCLIMCTRL = 1<<13;						// enable current limiter
	EMU->DCDCCTRL = 0;								// bypass DCDC
	EMU->PWRCTRL = EMU_PWRCTRL_REGPWRSEL;			// power analog blocks from DVDD
}

void CMU_setup(void)
{
	CMU->OSCENCMD = CMU_OSCENCMD_LFXOEN+CMU_OSCENCMD_LFRCODIS+CMU_OSCENCMD_AUXHFRCOEN;
	while (!(CMU->STATUS & CMU_STATUS_LFXORDY)){}	// wait for LFXO stabilize
	CMU->HFCLKSEL = CMU_HFCLKSEL_HF_HFRCO;			// select 19 MHz HFRCO as closk source
	CMU->HFBUSCLKEN0 = CMU_HFBUSCLKEN0_LE;			// enable LE clock access
	CMU->LFACLKSEL = CMU_LFACLKSEL_LFA_LFXO;		// set LFXO as LFA
	CMU->LFECLKSEL = CMU_LFECLKSEL_LFE_LFXO;
}

void GPIO_setup(void)								// configure GPIO ports
{
	CMU->HFBUSCLKEN0 |= CMU_HFBUSCLKEN0_GPIO;
	CMU->DBGCLKSEL = 1;
	(GPIO->P[3]).MODEH |= GPIO_P_MODEH_MODE8_PUSHPULL;	// red LED control
}
